diff --git a/sys/dev/netif/re/re.c b/sys/dev/netif/re/re.c
index dfe6b3a706..16958e8335 100644
--- a/sys/dev/netif/re/re.c
+++ b/sys/dev/netif/re/re.c
@@ -4503,19 +5568,15 @@ static void re_hw_start_unlock(struct re_softc *sc)
                                       BIT_9
                                      );
 
-                CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) | BIT_0);
-                CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) | BIT_5 |BIT_7);
+                CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) | BIT_5);
                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) & ~BIT_0);
 
                 CSR_WRITE_1(sc, 0xD0, CSR_READ_1(sc, 0xD0) | BIT_6);
                 CSR_WRITE_1(sc, 0xF2, CSR_READ_1(sc, 0xF2) | BIT_6);
 
                 CSR_WRITE_1 (sc, RE_MTPS, 0x27);
-                ifp->if_capenable &= ~IFCAP_HWCSUM ;
+                ifp->if_capenable &= ~IFCAP_HWCSUM;
                 ifp->if_hwassist &= ~RE_CSUM_FEATURES;
-
-                /* disable clock request. */
-                pci_write_config(sc->dev, 0x81, 0x00, 1);
         } else if (macver == 0x24000000) {
                 if (pci_read_config(sc->dev, 0x81, 1)==1) {
                         CSR_WRITE_1(sc, RE_DBG_reg, 0x98);
@@ -4541,12 +5602,7 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 MP_WriteEPhyUshort(sc, 0x06, 0xAF25);
                 MP_WriteEPhyUshort(sc, 0x07, 0x8E68);
         } else if (macver == 0x40800000) {
-                if (pci_read_config(sc->dev, 0x80, 1) & 0x03) {
-                        CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) | 1);
-                        CSR_WRITE_1(sc, 0xF1, CSR_READ_1(sc, 0xF1) | 0x80);
-                        CSR_WRITE_1(sc, 0xF2, CSR_READ_1(sc, 0xF2) | 0x80);
-                        CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) | 0x80);
-                }
+                CSR_WRITE_1(sc, 0xF2, CSR_READ_1(sc, 0xF2) | 0x80);
                 CSR_WRITE_1(sc, 0xF1, CSR_READ_1(sc, 0xF1) | 0x28);
                 CSR_WRITE_1(sc, 0xD3, CSR_READ_1(sc, 0xD3) | 0x0C);
                 CSR_WRITE_1(sc, 0xD3, CSR_READ_1(sc, 0xD3) & ~BIT_7);
@@ -4609,6 +5665,8 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 data8 |= 0x50;
                 pci_write_config(sc->dev, 0x79, data8, 1);
 
+                CSR_WRITE_1(sc, RE_TDFNR, 0x8);
+
                 Data32 = re_eri_read(sc, 0xD4, 4, ERIAR_ExGMAC);
                 Data32 |= BIT_11 | BIT_10;
                 re_eri_write(sc, 0xD4, 4, Data32, ERIAR_ExGMAC);
@@ -4663,8 +5721,6 @@ static void re_hw_start_unlock(struct re_softc *sc)
                                       BIT_9
                                      );
 
-                CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) | BIT_0);
-                CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) | BIT_7);
                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) & ~BIT_0);
 
                 CSR_WRITE_1(sc, 0xD0, CSR_READ_1(sc, 0xD0) | BIT_6);
@@ -4673,7 +5729,7 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 CSR_WRITE_1 (sc, RE_MTPS, 0x27);
 
                 if (ifp->if_mtu > ETHERMTU) {
-                        ifp->if_capenable &= ~IFCAP_HWCSUM ;
+                        ifp->if_capenable &= ~IFCAP_HWCSUM;
                         ifp->if_hwassist &= ~RE_CSUM_FEATURES;
                 } else {
                         if (sc->re_tx_cstag) {
@@ -4684,9 +5740,6 @@ static void re_hw_start_unlock(struct re_softc *sc)
                                 ifp->if_capenable |= IFCAP_RXCSUM;
                         }
                 }
-
-                /* disable clock request. */
-                pci_write_config(sc->dev, 0x81, 0x00, 1);
         } else if (macver == 0x48800000) {
                 /*set configuration space offset 0x70f to 0x27*/
                 Data32 = MP_ReadPciEConfigSpace(sc, 0x870c);
@@ -4699,6 +5752,8 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 data8 |= 0x50;
                 pci_write_config(sc->dev, 0x79, data8, 1);
 
+                CSR_WRITE_1(sc, RE_TDFNR, 0x8);
+
                 Data32 = re_eri_read(sc, 0xD4, 4, ERIAR_ExGMAC);
                 Data32 |= BIT_11 | BIT_10;
                 re_eri_write(sc, 0xD4, 4, Data32, ERIAR_ExGMAC);
@@ -4748,8 +5803,6 @@ static void re_hw_start_unlock(struct re_softc *sc)
                                       BIT_9
                                      );
 
-                CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) | BIT_0);
-                CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) | BIT_7);
                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) & ~BIT_0);
 
                 CSR_WRITE_1(sc, 0xD0, CSR_READ_1(sc, 0xD0) | BIT_6);
@@ -4758,7 +5811,7 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 CSR_WRITE_1 (sc, RE_MTPS, 0x27);
 
                 if (ifp->if_mtu > ETHERMTU) {
-                        ifp->if_capenable &= ~IFCAP_HWCSUM ;
+                        ifp->if_capenable &= ~IFCAP_HWCSUM;
                         ifp->if_hwassist &= ~RE_CSUM_FEATURES;
                 } else {
                         if (sc->re_tx_cstag) {
@@ -4769,16 +5822,8 @@ static void re_hw_start_unlock(struct re_softc *sc)
                                 ifp->if_capenable |= IFCAP_RXCSUM;
                         }
                 }
-
-                /* disable clock request. */
-                pci_write_config(sc->dev, 0x81, 0x00, 1);
         } else if (macver == 0x44800000) {
-                if (pci_read_config(sc->dev, 0x80, 1) & 0x03) {
-                        CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) | 1);
-                        CSR_WRITE_1(sc, 0xF1, CSR_READ_1(sc, 0xF1) | 0x80);
-                        CSR_WRITE_1(sc, 0xF2, CSR_READ_1(sc, 0xF2) | 0x80);
-                        CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) | 0x80);
-                }
+                CSR_WRITE_1(sc, 0xF2, CSR_READ_1(sc, 0xF2) | 0x80);
                 CSR_WRITE_1(sc, 0xF1, CSR_READ_1(sc, 0xF1) | 0x28);
                 CSR_WRITE_1(sc, 0xD3, CSR_READ_1(sc, 0xD3) | 0x0C);
                 CSR_WRITE_1(sc, 0xD3, CSR_READ_1(sc, 0xD3) & ~BIT_7);
@@ -4788,8 +5833,6 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) & ~BIT_0);
         } else if (macver == 0x4C000000 || macver == 0x50800000 ||
                    macver == 0x5C800000 || macver == 0x54000000) {
-                CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) & ~BIT_0);
-                CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) & ~BIT_7);
                 CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) | BIT_5);
 
                 if (sc->re_type == MACFG_59) {
@@ -4816,7 +5859,7 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 /*set configuration space offset 0x70f to 0x17*/
                 Data32 = MP_ReadPciEConfigSpace(sc, 0x870c);
                 Data32 &=0xC0FFFFFF;
-                Data32 |= (0x17 << 24);
+                Data32 |= (0x27 << 24);
                 MP_WritePciEConfigSpace(sc, 0x870c, Data32);
 
                 data8 = pci_read_config(sc->dev, 0x79, 1);
@@ -4824,6 +5867,8 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 data8 |= 0x50;
                 pci_write_config(sc->dev, 0x79, data8, 1);
 
+                CSR_WRITE_1(sc, RE_TDFNR, 0x4);
+
                 if (sc->re_type == MACFG_56 || sc->re_type == MACFG_57) {
                         Data32 = MP_ReadPciEConfigSpace(sc, 0x2710);
                         Data32 &=0xFFFF0FFF;
@@ -4850,6 +5895,9 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 re_eri_write(sc, 0xD0, 1, 0x48, ERIAR_ExGMAC);
                 re_eri_write(sc, 0xE8, 4, 0x00100006, ERIAR_ExGMAC);
 
+                if (sc->re_type == MACFG_68 || sc->re_type == MACFG_69)
+                        MP_WriteMcuAccessRegWord(sc, 0xE054, 0xFC01);
+
                 re_eri_write(sc, 0x5F0, 4, 0x4F87, ERIAR_ExGMAC);
 
                 Data32 = re_eri_read(sc, 0xdc, 4, ERIAR_ExGMAC);
@@ -4905,6 +5953,9 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         MP_WriteEPhyUshort(sc, 0x00, 0x10A3);
 
                         MP_WriteEPhyUshort(sc, 0x06, 0xF050);
+
+                        SetPCIePhyBit(sc, 0x04, BIT_4);
+                        ClearPCIePhyBit(sc, 0x1D, BIT_14);
                 } else if (sc->re_type == MACFG_60) {
                         ClearPCIePhyBit(sc, 0x00, BIT_3);
                         ClearAndSetPCIePhyBit(sc,
@@ -4923,6 +5974,9 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         SetPCIePhyBit(sc, 0x00, BIT_7);
 
                         SetPCIePhyBit(sc, 0x06, BIT_4);
+
+                        SetPCIePhyBit(sc, 0x04, BIT_4);
+                        SetPCIePhyBit(sc, 0x1D, BIT_14);
                 } else if (sc->re_type == MACFG_68 || sc->re_type == MACFG_69) {
                         ClearPCIePhyBit(sc, 0x1E, BIT_11);
 
@@ -4932,7 +5986,7 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         MP_WriteEPhyUshort(sc, 0x05, 0x2089);
                         MP_WriteEPhyUshort(sc, 0x06, 0x5881);
 
-                        MP_WriteEPhyUshort(sc, 0x04, 0x154A);
+                        MP_WriteEPhyUshort(sc, 0x04, 0x854A);
                         MP_WriteEPhyUshort(sc, 0x01, 0x068B);
                 }
 
@@ -4953,7 +6007,7 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         if (sc->RequireAdjustUpsTxLinkPulseTiming) {
                                 data16 = MP_ReadMcuAccessRegWord(sc, 0xD412);
                                 data16 &= ~(0x0FFF);
-                                data16 |= sc->SwrCnt1msIni ;
+                                data16 |= sc->SwrCnt1msIni;
                                 MP_WriteMcuAccessRegWord(sc, 0xD412, data16);
                         }
 
@@ -4979,9 +6033,6 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         MP_WriteMcuAccessRegWord(sc, 0xE0D6, data16);
                 }
 
-
-                CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) | BIT_0);
-                CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) | BIT_7);
                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) & ~BIT_0);
 
                 CSR_WRITE_1(sc, 0xD0, CSR_READ_1(sc, 0xD0) | BIT_6);
@@ -5000,7 +6051,7 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 }
 
                 if (ifp->if_mtu > ETHERMTU) {
-                        ifp->if_capenable &= ~IFCAP_HWCSUM ;
+                        ifp->if_capenable &= ~IFCAP_HWCSUM;
                         ifp->if_hwassist &= ~RE_CSUM_FEATURES;
                 } else {
                         if (sc->re_tx_cstag) {
@@ -5011,18 +6062,11 @@ static void re_hw_start_unlock(struct re_softc *sc)
                                 ifp->if_capenable |= IFCAP_RXCSUM;
                         }
                 }
-
-                /* disable clock request. */
-                pci_write_config(sc->dev, 0x81, 0x00, 1);
         } else if (macver == 0x50000000) {
-
-                CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) & ~BIT_0);
-                CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) & ~BIT_7);
-
                 /*set configuration space offset 0x70f to 0x17*/
                 Data32 = MP_ReadPciEConfigSpace(sc, 0x870c);
                 Data32 &=0xC0FFFFFF;
-                Data32 |= (0x17 << 24);
+                Data32 |= (0x27 << 24);
                 MP_WritePciEConfigSpace(sc, 0x870c, Data32);
 
                 data8 = pci_read_config(sc->dev, 0x79, 1);
@@ -5087,9 +6131,6 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         SetPCIePhyBit(sc, 0x1E, BIT_13);
                 }
 
-
-                CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) | BIT_0);
-                CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) | BIT_7);
                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) & ~BIT_0);
 
                 CSR_WRITE_1(sc, 0xD0, CSR_READ_1(sc, 0xD0) | BIT_6);
@@ -5118,7 +6159,7 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 MP_WriteMcuAccessRegWord(sc, 0xC142, 0xFFFF);
 
                 if (ifp->if_mtu > ETHERMTU) {
-                        ifp->if_capenable &= ~IFCAP_HWCSUM ;
+                        ifp->if_capenable &= ~IFCAP_HWCSUM;
                         ifp->if_hwassist &= ~RE_CSUM_FEATURES;
                 } else {
                         if (sc->re_tx_cstag) {
@@ -5129,9 +6170,143 @@ static void re_hw_start_unlock(struct re_softc *sc)
                                 ifp->if_capenable |= IFCAP_RXCSUM;
                         }
                 }
+        } else if (macver == 0x54800000) {
+                MP_WriteMcuAccessRegWord(sc, 0xD400, MP_ReadMcuAccessRegWord(sc, 0xD400) & ~(BIT_0));
+
+                if (sc->RequireAdjustUpsTxLinkPulseTiming) {
+                        data16 = MP_ReadMcuAccessRegWord(sc, 0xD412);
+                        data16 &= ~(0x0FFF);
+                        data16 |= sc->SwrCnt1msIni;
+                        MP_WriteMcuAccessRegWord(sc, 0xD412, data16);
+                }
 
-                /* disable clock request. */
-                pci_write_config(sc->dev, 0x81, 0x00, 1);
+                data16 = MP_ReadMcuAccessRegWord(sc, 0xE056);
+                data16 &= ~(BIT_7 | BIT_6 | BIT_5 | BIT_4);
+                data16 |= (BIT_6 | BIT_5 | BIT_4);
+                MP_WriteMcuAccessRegWord(sc, 0xE056, data16);
+
+                OOB_mutex_lock(sc);
+                data16 = MP_ReadMcuAccessRegWord(sc, 0xE052);
+                if (sc->re_type == MACFG_71)
+                        data16 |= BIT_3;
+                else
+                        data16 &= ~BIT_3;
+                MP_WriteMcuAccessRegWord(sc, 0xE052, data16);
+                OOB_mutex_unlock(sc);
+
+                data16 = MP_ReadMcuAccessRegWord(sc, 0xD420);
+                data16 &= ~(BIT_11 | BIT_10 | BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_5 | BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0);
+                data16 |= 0x47F;
+                MP_WriteMcuAccessRegWord(sc, 0xD420, data16);
+
+                CSR_WRITE_1(sc, RE_TDFNR, 0x4);
+
+                data16 = MP_ReadMcuAccessRegWord(sc, 0xE63E);
+                data16 &= ~(BIT_3 | BIT_2 | BIT_1);
+                MP_WriteMcuAccessRegWord(sc, 0xE63E, data16);
+                data16 |= (BIT_0);
+                MP_WriteMcuAccessRegWord(sc, 0xE63E, data16);
+                data16 &= ~(BIT_0);
+                MP_WriteMcuAccessRegWord(sc, 0xE63E, data16);
+                MP_WriteMcuAccessRegWord(sc, 0xC094, 0x0);
+                MP_WriteMcuAccessRegWord(sc, 0xC09E, 0x0);
+
+                /*set configuration space offset 0x70f to 0x27*/
+                Data32 = MP_ReadPciEConfigSpace(sc, 0x870c);
+                Data32 &=0xC0FFFFFF;
+                Data32 |= (0x27 << 24);
+                MP_WritePciEConfigSpace(sc, 0x870c, Data32);
+
+                data8 = pci_read_config(sc->dev, 0x79, 1);
+                data8 &= ~0x70;
+                data8 |= 0x50;
+                pci_write_config(sc->dev, 0x79, data8, 1);
+
+                Data32 = re_eri_read(sc, 0xD4, 4, ERIAR_ExGMAC);
+                Data32 |= BIT_7 | BIT_8 | BIT_9 | BIT_10 | BIT_11 | BIT_12;
+                re_eri_write(sc, 0xD4, 4, Data32, ERIAR_ExGMAC);
+
+                re_eri_write(sc, 0xC8, 4, 0x00080002, ERIAR_ExGMAC);
+                re_eri_write(sc, 0xCC, 1, 0x2F, ERIAR_ExGMAC);
+                re_eri_write(sc, 0xD0, 1, 0x5F, ERIAR_ExGMAC);
+                re_eri_write(sc, 0xE8, 4, 0x00100006, ERIAR_ExGMAC);
+
+                MP_WriteMcuAccessRegWord(sc, 0xE054, 0xFC01);
+
+                OOB_mutex_lock(sc);
+                Data32 = re_eri_read(sc, 0x5F0, 4, ERIAR_ExGMAC);
+                Data32 |= (BIT_8 | BIT_9 | BIT_10 | BIT_11);
+                re_eri_write(sc, 0x5F0, 4, Data32, ERIAR_ExGMAC);
+                OOB_mutex_unlock(sc);
+
+                Data32 = re_eri_read(sc, 0xdc, 4, ERIAR_ExGMAC);
+                Data32 &= ~BIT_0;
+                re_eri_write(sc, 0xdc, 1, Data32, ERIAR_ExGMAC);
+                Data32 |= BIT_0;
+                re_eri_write(sc, 0xdc, 1, Data32, ERIAR_ExGMAC);
+
+                Data32 = re_eri_read(sc, 0x2FC, 4, ERIAR_ExGMAC);
+                Data32 &= ~(BIT_0 | BIT_1 | BIT_2);
+                Data32 |= (BIT_0);
+                re_eri_write(sc, 0x2FC, 4, Data32, ERIAR_ExGMAC);
+
+                Data32 = re_eri_read(sc, 0x1B0, 4, ERIAR_ExGMAC);
+                Data32 &= ~BIT_12;
+                re_eri_write(sc, 0x1B0, 4, Data32, ERIAR_ExGMAC);
+
+                Data32 = re_eri_read(sc, 0x1D0, 1, ERIAR_ExGMAC);
+                Data32 &= ~BIT_1;
+                re_eri_write(sc, 0x1D0, 1, Data32, ERIAR_ExGMAC);
+
+                re_eri_write(sc, 0xC0, 2, 0x0000, ERIAR_ExGMAC);
+                re_eri_write(sc, 0xB8, 4, 0x00000000, ERIAR_ExGMAC);
+
+                CSR_WRITE_4(sc, RE_TXCFG, CSR_READ_4(sc, RE_TXCFG) | BIT_7);
+                CSR_WRITE_1(sc, 0xD3, CSR_READ_1(sc, 0xD3) & ~BIT_7);
+                CSR_WRITE_1(sc, 0x1B, CSR_READ_1(sc, 0x1B) & ~0x07);
+
+                CSR_WRITE_2 (sc, RE_CPlusCmd, 0x2060);
+
+                CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) & ~BIT_0);
+
+                CSR_WRITE_1(sc, 0xD0, CSR_READ_1(sc, 0xD0) | BIT_6);
+                CSR_WRITE_1(sc, 0xF2, CSR_READ_1(sc, 0xF2) | BIT_6);
+
+                CSR_WRITE_1(sc, 0xD0, CSR_READ_1(sc, 0xD0) | BIT_7);
+
+                CSR_WRITE_1(sc, 0xF2, CSR_READ_1(sc, 0xF2) & ~BIT_3);
+
+                if (ifp->if_mtu > ETHERMTU)
+                        CSR_WRITE_1 (sc, RE_MTPS, 0x27);
+
+                data16 = MP_ReadMcuAccessRegWord(sc, 0xD3E2);
+                data16 &= 0xF000;
+                data16 |= 0x3A9;
+                MP_WriteMcuAccessRegWord(sc, 0xD3E2, data16);
+
+                data16 = MP_ReadMcuAccessRegWord(sc, 0xD3E4);
+                data16 &= 0xFF00;
+                MP_WriteMcuAccessRegWord(sc, 0xD3E4, data16);
+
+                data16 = MP_ReadMcuAccessRegWord(sc, 0xE860);
+                data16 |= BIT_7;
+                MP_WriteMcuAccessRegWord(sc, 0xE860, data16);
+
+                MP_WriteMcuAccessRegWord(sc, 0xC140, 0xFFFF);
+                MP_WriteMcuAccessRegWord(sc, 0xC142, 0xFFFF);
+
+                if (ifp->if_mtu > ETHERMTU) {
+                        ifp->if_capenable &= ~IFCAP_HWCSUM;
+                        ifp->if_hwassist &= ~RE_CSUM_FEATURES;
+                } else {
+                        if (sc->re_tx_cstag) {
+                                ifp->if_capenable |= IFCAP_TXCSUM;
+                                ifp->if_hwassist |= RE_CSUM_FEATURES;
+                        }
+                        if (sc->re_rx_cstag) {
+                                ifp->if_capenable |= IFCAP_RXCSUM;
+                        }
+                }
         }
 
         //clear io_rdy_l23
@@ -5152,26 +6327,59 @@ static void re_hw_start_unlock(struct re_softc *sc)
         case MACFG_67:
         case MACFG_68:
         case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) & ~BIT_1);
                 break;
         }
 
-        //clear wol
-        re_clrwol(sc);
-
-        data16 = CSR_READ_2(sc, RE_CPlusCmd);
-        if ((ifp->if_capenable & IFCAP_VLAN_HWTAGGING) != 0)
-                data16 |= RL_CPLUSCMD_VLANSTRIP;
-        else
-                data16 &= ~RL_CPLUSCMD_VLANSTRIP;
-
-        if ((ifp->if_capenable & IFCAP_RXCSUM) != 0)
+        switch(sc->re_type) {
+        case MACFG_36:
+        case MACFG_37:
+        case MACFG_38:
+        case MACFG_39:
+        case MACFG_42:
+        case MACFG_43:
+        case MACFG_50:
+        case MACFG_51:
+        case MACFG_52:
+        case MACFG_53:
+        case MACFG_54:
+        case MACFG_55:
+        case MACFG_56:
+        case MACFG_57:
+        case MACFG_58:
+        case MACFG_59:
+        case MACFG_60:
+        case MACFG_61:
+        case MACFG_62:
+        case MACFG_67:
+        case MACFG_68:
+        case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
+                CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) | BIT_0);
+                CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) | BIT_7);
+                CSR_WRITE_1(sc, 0xF1, CSR_READ_1(sc, 0xF1) | BIT_7);
+                break;
+        }
+
+        //clear wol
+        re_clrwol(sc);
+
+        data16 = CSR_READ_2(sc, RE_CPlusCmd);
+        if ((ifp->if_capenable & IFCAP_VLAN_HWTAGGING) != 0)
+                data16 |= RL_CPLUSCMD_VLANSTRIP;
+        else
+                data16 &= ~RL_CPLUSCMD_VLANSTRIP;
+
+        if ((ifp->if_capenable & IFCAP_RXCSUM) != 0)
                 data16 |= RL_RxChkSum;
         else
                 data16 &= ~RL_RxChkSum;
         CSR_WRITE_2 (sc, RE_CPlusCmd, data16);
 
-        CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_OFF);
+        re_disable_cfg9346_write(sc);
         //CSR_WRITE_1(sc, 0xec, 0x3f);
 
         if (sc->re_device_id == RT_DEVICEID_8169 || sc->re_device_id == RT_DEVICEID_8169SC) {
@@ -5245,25 +6453,7 @@ static void re_init_unlock(void *xsc)  	/* Software & Hardware Initialize */
 #endif	/* !__DragonFly__ */
 
         /* Init our MAC address */
-        CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_WRITECFG);
-        CSR_WRITE_4(sc, RE_IDR0,
-                    htole32(*(u_int32_t *)(&eaddr.eaddr[0])));
-        CSR_WRITE_4(sc, RE_IDR4,
-                    htole32(*(u_int32_t *)(&eaddr.eaddr[4])));
-
-        switch (sc->re_type) {
-        case MACFG_36:
-        case MACFG_37:
-        case MACFG_54:
-        case MACFG_55:
-                CSR_WRITE_4(sc, RE_SecMAC0,
-                            htole32(*(u_int32_t *)(&eaddr.eaddr[0])));
-                CSR_WRITE_2(sc, RE_SecMAC4,
-                            htole16(*(u_int16_t *)(&eaddr.eaddr[4])));
-                break;
-        }
-
-        CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_OFF);
+        re_rar_set(sc, eaddr.eaddr);
 
 #ifndef __DragonFly__
         re_hw_start_unlock(sc);
@@ -5425,6 +6615,8 @@ static void re_reset(struct re_softc *sc)
         case MACFG_67:
         case MACFG_68:
         case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
                 DELAY(2000);
                 break;
         default:
@@ -5455,7 +6647,6 @@ static u_int8_t re_link_ok(struct re_softc *sc)
         return retval;
 }
 
-#ifndef __DragonFly__
 static void
 re_set_wol_linkspeed(struct re_softc *sc)
 {
@@ -5465,7 +6656,7 @@ re_set_wol_linkspeed(struct re_softc *sc)
         MP_WritePhyUshort(sc, 0x1F, 0x0000);
 
         wol_link_speed = RE_WOL_LINK_SPEED_100M_FIRST;
-        if (!re_check_dash(sc)) {
+        if (!sc->re_dash) {
                 if (re_link_ok(sc)) {
                         u_int16_t anlpar;
 
@@ -5501,6 +6692,7 @@ re_set_wol_linkspeed(struct re_softc *sc)
         }
 }
 
+#ifndef __DragonFly__
 static void
 re_setwol(struct re_softc *sc)
 {
@@ -5522,7 +6714,7 @@ re_setwol(struct re_softc *sc)
                 return;
 
         /* Enable config register write. */
-        CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_WRITECFG);
+        re_enable_cfg9346_write(sc);
 
         /* Enable PME. */
         if (sc->re_device_id==RT_DEVICEID_8169 || sc->re_device_id==RT_DEVICEID_8169SC) {
@@ -5562,7 +6754,7 @@ re_setwol(struct re_softc *sc)
         CSR_WRITE_1(sc, RE_CFG5, v);
 
         /* Config register write done. */
-        CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_OFF);
+        re_disable_cfg9346_write(sc);
 
         /*
          * It seems that hardware resets its link speed to 100Mbps in
@@ -5610,7 +6802,7 @@ re_clrwol(struct re_softc *sc)
         pci_write_config(sc->dev, pmc + PCIR_POWER_STATUS, pmstat, 2);
 
         /* Enable config register write. */
-        CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_WRITECFG);
+        re_enable_cfg9346_write(sc);
 
         if (sc->re_device_id==RT_DEVICEID_8169 || sc->re_device_id==RT_DEVICEID_8169SC) {
                 v = CSR_READ_1(sc, RE_CFG1);
@@ -5640,7 +6832,7 @@ re_clrwol(struct re_softc *sc)
         CSR_WRITE_1(sc, RE_CFG5, v);
 
         /* Config register write done. */
-        CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_OFF);
+        re_disable_cfg9346_write(sc);
 }
 
 /*
@@ -5792,7 +6984,7 @@ static void re_start(struct ifnet *ifp)  	/* Transmit Packet*/
 
                 //vlan
                 if (m_head->m_flags & M_VLANTAG)
-                        opts2 |= bswap16(m_head->m_pkthdr.ether_vtag) | RL_TDESC_VLANCTL_TAG ;
+                        opts2 |= bswap16(m_head->m_pkthdr.ether_vtag) | RL_TDESC_VLANCTL_TAG;
                 ptr = m_head;
                 PktLen = ptr->m_pkthdr.len;
 #ifdef _DEBUG_
@@ -6338,11 +7530,11 @@ static void re_set_multicast_reg(struct re_softc *sc, u_int32_t mask0, u_int32_t
                 enable_cfg_reg_write = 1;
 
         if (enable_cfg_reg_write)
-                CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_WRITECFG);
+                re_enable_cfg9346_write(sc);
         CSR_WRITE_4(sc, RE_MAR0, mask0);
         CSR_WRITE_4(sc, RE_MAR4, mask4);
         if (enable_cfg_reg_write)
-                CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_OFF);
+                re_disable_cfg9346_write(sc);
 
         return;
 }
@@ -6440,7 +7632,7 @@ static void re_setmulti(struct re_softc *sc)
         TAILQ_FOREACH(ifma,&ifp->if_multiaddrs,ifma_link)
 #endif
 #else	/* __DragonFly__ */
-        TAILQ_FOREACH(ifma,&ifp->if_multiaddrs,ifma_link)
+	TAILQ_FOREACH(ifma,&ifp->if_multiaddrs,ifma_link)
 #endif	/* !__DragonFly__ */
         {
                 if (ifma->ifma_addr->sa_family != AF_LINK)
@@ -6677,7 +7869,8 @@ static void re_link_on_patch(struct re_softc *sc)
                     sc->re_type == MACFG_58 || sc->re_type == MACFG_59 ||
                     sc->re_type == MACFG_60 || sc->re_type == MACFG_61 ||
                     sc->re_type == MACFG_62 || sc->re_type == MACFG_67 ||
-                    sc->re_type == MACFG_68 || sc->re_type == MACFG_69) &&
+                    sc->re_type == MACFG_68 || sc->re_type == MACFG_69 ||
+                    sc->re_type == MACFG_70 || sc->re_type == MACFG_71) &&
                    (ifp->if_flags & IFF_UP)) {
                 if (CSR_READ_1(sc, RE_PHY_STATUS) & RL_PHY_STATUS_FULL_DUP)
                         CSR_WRITE_4(sc, RE_TXCFG, (CSR_READ_4(sc, RE_TXCFG) | (BIT_24 | BIT_25)) & ~BIT_19);
@@ -6694,6 +7887,15 @@ static void re_link_on_patch(struct re_softc *sc)
                 }
         }
 
+        if ((sc->re_type == MACFG_70 || sc->re_type == MACFG_71) &&
+            (CSR_READ_1(sc, RE_PHY_STATUS) & RL_PHY_STATUS_10M)) {
+                uint32_t Data32;
+
+                Data32 = re_eri_read(sc, 0x1D0, 1, ERIAR_ExGMAC);
+                Data32 |= BIT_1;
+                re_eri_write(sc, 0x1D0, 1, Data32, ERIAR_ExGMAC);
+        }
+
 #ifndef __DragonFly__
         re_init_unlock(sc);
 #endif
@@ -6834,7 +8036,8 @@ static int re_ifmedia_upd(struct ifnet *ifp)
         if (IFM_TYPE(ifm->ifm_media) != IFM_ETHER)
                 return(EINVAL);
 
-        if (sc->re_type == MACFG_68 || sc->re_type == MACFG_69) {
+        if (sc->re_type == MACFG_68 || sc->re_type == MACFG_69 ||
+            sc->re_type == MACFG_70 || sc->re_type == MACFG_71) {
                 //Disable Giga Lite
                 MP_WritePhyUshort(sc, 0x1F, 0x0A42);
                 ClearEthPhyBit(sc, 0x14, BIT_9);
@@ -6983,7 +8186,7 @@ static int re_enable_EEE(struct re_softc *sc)
         case MACFG_43:
                 re_eri_write(sc, 0x1B0, 2, 0xED03, ERIAR_ExGMAC);
                 MP_WritePhyUshort(sc, 0x1F, 0x0004);
-                if (CSR_READ_1(sc,0xEF) & 0x02) {
+                if (CSR_READ_1(sc, 0xEF) & 0x02) {
                         MP_WritePhyUshort(sc, 0x10, 0x731F);
                         MP_WritePhyUshort(sc, 0x19, 0x7630);
                 } else {
@@ -7056,27 +8259,27 @@ static int re_enable_EEE(struct re_softc *sc)
         case MACFG_50:
         case MACFG_51:
         case MACFG_52:
-                data = re_eri_read(sc, 0x1B0 ,4,ERIAR_ExGMAC) | 0x0003;
+                data = re_eri_read(sc, 0x1B0, 4, ERIAR_ExGMAC) | 0x0003;
                 re_eri_write(sc, 0x1B0, 4, data, ERIAR_ExGMAC);
-                MP_WritePhyUshort(sc,0x1F , 0x0007);
-                MP_WritePhyUshort(sc,0x1E , 0x0020);
+                MP_WritePhyUshort(sc, 0x1F, 0x0007);
+                MP_WritePhyUshort(sc, 0x1E, 0x0020);
                 data = MP_ReadPhyUshort(sc, 0x15)|0x0100;
-                MP_WritePhyUshort(sc,0x15 , data);
-                MP_WritePhyUshort(sc,0x1F , 0x0005);
-                MP_WritePhyUshort(sc,0x05 , 0x8B85);
+                MP_WritePhyUshort(sc, 0x15, data);
+                MP_WritePhyUshort(sc, 0x1F, 0x0005);
+                MP_WritePhyUshort(sc, 0x05, 0x8B85);
                 data = MP_ReadPhyUshort(sc, 0x06)|0x2000;
-                MP_WritePhyUshort(sc,0x06 , data);
-                MP_WritePhyUshort(sc,0x1F , 0x0000);
-                MP_WritePhyUshort(sc,0x0D , 0x0007);
-                MP_WritePhyUshort(sc,0x0E , 0x003C);
-                MP_WritePhyUshort(sc,0x0D , 0x4007);
-                MP_WritePhyUshort(sc,0x0E , 0x0006);
-                MP_WritePhyUshort(sc,0x1D , 0x0000);
+                MP_WritePhyUshort(sc, 0x06, data);
+                MP_WritePhyUshort(sc, 0x1F, 0x0000);
+                MP_WritePhyUshort(sc, 0x0D, 0x0007);
+                MP_WritePhyUshort(sc, 0x0E, 0x003C);
+                MP_WritePhyUshort(sc, 0x0D, 0x4007);
+                MP_WritePhyUshort(sc, 0x0E, 0x0006);
+                MP_WritePhyUshort(sc, 0x1D, 0x0000);
                 break;
 
         case MACFG_38:
         case MACFG_39:
-                data = re_eri_read(sc, 0x1B0 ,4,ERIAR_ExGMAC);
+                data = re_eri_read(sc, 0x1B0, 4, ERIAR_ExGMAC);
                 data |= BIT_1 | BIT_0;
                 re_eri_write(sc, 0x1B0, 4, data, ERIAR_ExGMAC);
                 MP_WritePhyUshort(sc, 0x1F, 0x0004);
@@ -7109,6 +8312,8 @@ static int re_enable_EEE(struct re_softc *sc)
         case MACFG_67:
         case MACFG_68:
         case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
                 data = re_eri_read(sc, 0x1B0, 4, ERIAR_ExGMAC);
                 data |= BIT_1 | BIT_0;
                 re_eri_write(sc, 0x1B0, 4, data, ERIAR_ExGMAC);
@@ -7147,7 +8352,7 @@ static int re_enable_EEE(struct re_softc *sc)
                 SetEthPhyBit(sc, 0x10, BIT_4);
                 MP_WritePhyUshort(sc, 0x1F, 0x0000);
 
-                MP_WritePhyUshort(sc,0x1F, 0x0B80);
+                MP_WritePhyUshort(sc, 0x1F, 0x0B80);
                 WaitCnt = 0;
                 do {
                         PhyRegValue = MP_ReadPhyUshort(sc, 0x10);
@@ -7217,6 +8422,19 @@ static int re_enable_EEE(struct re_softc *sc)
                 data |= (BIT_4 | BIT_5 | BIT_6);
                 MP_WriteMcuAccessRegWord(sc, 0xE056, data);
                 break;
+        case MACFG_70:
+        case MACFG_71:
+                OOB_mutex_lock(sc);
+                data = MP_ReadMcuAccessRegWord(sc, 0xE052);
+                data &= ~BIT_0;
+                MP_WriteMcuAccessRegWord(sc, 0xE052, data);
+                OOB_mutex_unlock(sc);
+                data = MP_ReadMcuAccessRegWord(sc, 0xE056);
+                data &= 0xFF0F;
+                data |= (BIT_4 | BIT_5 | BIT_6);
+                MP_WriteMcuAccessRegWord(sc, 0xE056, data);
+                MP_WriteMcuAccessRegWord(sc, 0xEA80, 0x0003);
+                break;
         case MACFG_68:
         case MACFG_69:
                 data = MP_ReadMcuAccessRegWord(sc, 0xE052);
